import os

import testinfra.utils.ansible_runner

testinfra_hosts = testinfra.utils.ansible_runner.AnsibleRunner(
    os.environ["MOLECULE_INVENTORY_FILE"]
).get_hosts("all")


def test_postgres_is_installed(host):
    postgres = host.package("postgresql14-server")
    assert postgres.is_installed


def test_postgres_running_and_enabled(host):
    postgres = host.service("postgresql-14")
    assert postgres.is_running
    assert postgres.is_enabled


def test_postgres_auth(host):
    login = host.run("PGPASSWORD=secure psql -U pgdemo -h localhost -c 'select 1' -q demo")
    assert login.succeeded


def test_postgres_socket(host):
    # Verify the socket is listening for HTTP traffic
    assert host.socket("tcp://127.0.0.1:5432").is_listening
